

#include "mmap-win.h"
     
    void *mmap(void *start, size_t length, int prot, int flags, int fd, off_t offset)
    {
    	if (prot & ~(PROT_READ | PROT_WRITE | PROT_EXEC))
    		return MAP_FAILED;
    	if (fd == -1) {
    		if (!(flags & MAP_ANON) || offset)
    			return MAP_FAILED;
    	} else if (flags & MAP_ANON)
    		return MAP_FAILED;
     
    	DWORD flProtect;
    	if (prot & PROT_WRITE) {
    		if (prot & PROT_EXEC)
    			flProtect = PAGE_EXECUTE_READWRITE;
    		else
    			flProtect = PAGE_READWRITE;
    	} else if (prot & PROT_EXEC) {
    		if (prot & PROT_READ)
    			flProtect = PAGE_EXECUTE_READ;
    		else if (prot & PROT_EXEC)
    			flProtect = PAGE_EXECUTE;
    	} else
    		flProtect = PAGE_READONLY;
     
    	off_t end = length + offset;
    	HANDLE mmap_fd, h;
    	if (fd == -1)
    		mmap_fd = INVALID_HANDLE_VALUE;
    	else
    		mmap_fd = (HANDLE)_get_osfhandle(fd);
    	h = CreateFileMapping(mmap_fd, NULL, flProtect, DWORD_HI(end), DWORD_LO(end), NULL);
    	if (h == NULL)
    		return MAP_FAILED;
     
    	DWORD dwDesiredAccess;
    	if (prot & PROT_WRITE)
    		dwDesiredAccess = FILE_MAP_WRITE;
    	else
    		dwDesiredAccess = FILE_MAP_READ;
    	if (prot & PROT_EXEC)
    		dwDesiredAccess |= FILE_MAP_EXECUTE;
    	if (flags & MAP_PRIVATE)
    		dwDesiredAccess |= FILE_MAP_COPY;
    	void *ret = MapViewOfFile(h, dwDesiredAccess, DWORD_HI(offset), DWORD_LO(offset), length);
    	if (ret == NULL) {
    		CloseHandle(h);
    		ret = MAP_FAILED;
    	}
    	return ret;
    }
     
    void munmap(void *addr, size_t length)
    {
    	UnmapViewOfFile(addr);
    	/* ruh-ro, we leaked handle from CreateFileMapping() ... */
    }
     
   // #undef DWORD_HI
   // #undef DWORD_LO